diff --git a/gcc/analyzer/program-state.cc b/gcc/analyzer/program-state.cc
index 6ad7dea7cc7..ae444ada7f3 100644
--- a/gcc/analyzer/program-state.cc
+++ b/gcc/analyzer/program-state.cc
@@ -1954,92 +1173,6 @@ program_state::can_merge_with_p (const program_state &other,
 				 program_state *out) const
 {
   gcc_assert (out);
-
-  if (m_region_model2)
-    return can_merge_with2_p (other, ext_state, point, out);
-
-  /* TODO:  initially I had an early reject here if there
-     are sm-differences between the states.  However, this was
-     falsely rejecting merger opportunities for states where the
-     only difference was in svalue_id ordering.  */
-
-  /* Attempt to merge the region_models.  */
-
-  svalue_id_merger_mapping sid_mapping (*m_region_model,
-					*other.m_region_model);
-  if (!m_region_model->can_merge_with_p (*other.m_region_model,
-					 out->m_region_model,
-					 &sid_mapping))
-    return false;
-
-  /* Copy m_checker_states to result, remapping svalue_ids using
-     sid_mapping.  */
-  int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (out->m_checker_states, i, smap)
-    delete smap;
-  out->m_checker_states.truncate (0);
-
-  /* Remap this and other's m_checker_states using sid_mapping.
-     Only merge states that have equality between the two end-results:
-     sm-state differences are likely to be interesting to end-users, and
-     hence are worth exploring as separate paths in the exploded graph.  */
-  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
-    {
-      sm_state_map *other_smap = other.m_checker_states[i];
-
-      /* If clone_with_remapping returns NULL for one of the input smaps,
-	 then it has sm-state for an svalue_id where the svalue_id is
-	 being mapped to svalue_id::null in its sid_mapping, meaning that
-	 the svalue is to be dropped during the merger.  We don't want
-	 to lose sm-state during a state merger, so return false for these
-	 cases.  */
-      sm_state_map *remapped_a_smap
-	= smap->clone_with_remapping (sid_mapping.m_map_from_a_to_m);
-      if (!remapped_a_smap)
-	return false;
-      sm_state_map *remapped_b_smap
-	= other_smap->clone_with_remapping (sid_mapping.m_map_from_b_to_m);
-      if (!remapped_b_smap)
-	{
-	  delete remapped_a_smap;
-	  return false;
-	}
-
-      /* Both states have sm-state for the same values; now ensure that the
-	 states are equal.  */
-      if (*remapped_a_smap == *remapped_b_smap)
-	{
-	  out->m_checker_states.safe_push (remapped_a_smap);
-	  delete remapped_b_smap;
-	}
-      else
-	{
-	  /* Don't merge if there are sm-state differences.  */
-	  delete remapped_a_smap;
-	  delete remapped_b_smap;
-	  return false;
-	}
-    }
-
-  impl_region_model_context ctxt (out, NULL, ext_state);
-  out->m_region_model->canonicalize (&ctxt);
-
-  return true;
-}
-
-/* Attempt to merge this state with OTHER, both using EXT_STATE.
-   Write the result to *OUT, canonicalizing it.
-   If the states were merged successfully, return true.  */
-// FIXME: POINT
-
-bool
-program_state::can_merge_with2_p (const program_state &other,
-				  const extrinsic_state &ext_state,
-				  const program_point &point,
-				  program_state *out) const
-{
-  gcc_assert (out);
   gcc_assert (m_region_model2);
 
   /* Early reject if there are sm-differences between the states.  */
@@ -2077,17 +1210,7 @@ program_state::validate (const extrinsic_state &ext_state) const
   return;
 #endif
 
-  if (!m_region_model)
-    return;
-  m_region_model->validate ();
-  gcc_assert (m_checker_states.length () == ext_state.get_num_checkers ());
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_checker_states, sm_idx, smap)
-    {
-      const state_machine &sm = ext_state.get_sm (sm_idx);
-      smap->validate (sm, m_region_model->get_num_svalues ());
-    }
+  gcc_assert (m_checker_states2.length () == ext_state.get_num_checkers ());
 }
 
 static void
@@ -2187,6 +1310,7 @@ program_state::detect_leaks2 (const program_state &src_state,
     (dest_svalues, dest_state.m_region_model2);
 }
 
+#if 0
 /* Dump this sm_change to PP.  */
 
 void
@@ -2353,6 +1477,7 @@ state_change::validate (const program_state &new_state,
   FOR_EACH_VEC_ELT (m_sm_changes, i, change)
     change->validate (new_state, ext_state);
 }
+#endif
 
 #if CHECKING_P
 
@@ -2391,127 +1516,6 @@ test_sm_state_map ()
   tree y = build_global_decl ("y", integer_type_node);
   tree z = build_global_decl ("z", integer_type_node);
 
-  /* Test setting states on svalue_id instances directly.  */
-  {
-    region_model model;
-    svalue_id sid_x = model.get_rvalue (x, NULL);
-    svalue_id sid_y = model.get_rvalue (y, NULL);
-    svalue_id sid_z = model.get_rvalue (z, NULL);
-
-    sm_state_map map;
-    ASSERT_TRUE (map.is_empty_p ());
-    ASSERT_EQ (map.get_state (sid_x), 0);
-
-    map.impl_set_state (sid_x, 42, sid_z);
-    ASSERT_EQ (map.get_state (sid_x), 42);
-    ASSERT_EQ (map.get_origin (sid_x), sid_z);
-    ASSERT_EQ (map.get_state (sid_y), 0);
-    ASSERT_FALSE (map.is_empty_p ());
-
-    map.impl_set_state (sid_y, 0, sid_z);
-    ASSERT_EQ (map.get_state (sid_y), 0);
-
-    map.impl_set_state (sid_x, 0, sid_z);
-    ASSERT_EQ (map.get_state (sid_x), 0);
-    ASSERT_TRUE (map.is_empty_p ());
-  }
-
-  /* Test setting states via equivalence classes.  */
-  {
-    region_model model;
-    svalue_id sid_x = model.get_rvalue (x, NULL);
-    svalue_id sid_y = model.get_rvalue (y, NULL);
-    svalue_id sid_z = model.get_rvalue (z, NULL);
-
-    sm_state_map map;
-    ASSERT_TRUE (map.is_empty_p ());
-    ASSERT_EQ (map.get_state (sid_x), 0);
-    ASSERT_EQ (map.get_state (sid_y), 0);
-
-    model.add_constraint (x, EQ_EXPR, y, NULL);
-
-    /* Setting x to a state should also update y, as they
-       are in the same equivalence class.  */
-    map.set_state (&model, sid_x, 5, sid_z);
-    ASSERT_EQ (map.get_state (sid_x), 5);
-    ASSERT_EQ (map.get_state (sid_y), 5);
-    ASSERT_EQ (map.get_origin (sid_x), sid_z);
-    ASSERT_EQ (map.get_origin (sid_y), sid_z);
-  }
-
-  /* Test equality and hashing.  */
-  {
-    region_model model;
-    svalue_id sid_y = model.get_rvalue (y, NULL);
-    svalue_id sid_z = model.get_rvalue (z, NULL);
-
-    sm_state_map map0;
-    sm_state_map map1;
-    sm_state_map map2;
-
-    ASSERT_EQ (map0.hash (), map1.hash ());
-    ASSERT_EQ (map0, map1);
-
-    map1.impl_set_state (sid_y, 5, sid_z);
-    ASSERT_NE (map0.hash (), map1.hash ());
-    ASSERT_NE (map0, map1);
-
-    /* Make the same change to map2.  */
-    map2.impl_set_state (sid_y, 5, sid_z);
-    ASSERT_EQ (map1.hash (), map2.hash ());
-    ASSERT_EQ (map1, map2);
-  }
-
-  /* Equality and hashing shouldn't depend on ordering.  */
-  {
-    sm_state_map map0;
-    sm_state_map map1;
-    sm_state_map map2;
-
-    ASSERT_EQ (map0.hash (), map1.hash ());
-    ASSERT_EQ (map0, map1);
-
-    map1.impl_set_state (svalue_id::from_int (14), 2, svalue_id::null ());
-    map1.impl_set_state (svalue_id::from_int (16), 3, svalue_id::null ());
-    map1.impl_set_state (svalue_id::from_int (1), 2, svalue_id::null ());
-    map1.impl_set_state (svalue_id::from_int (9), 2, svalue_id::null ());
-
-    map2.impl_set_state (svalue_id::from_int (1), 2, svalue_id::null ());
-    map2.impl_set_state (svalue_id::from_int (16), 3, svalue_id::null ());
-    map2.impl_set_state (svalue_id::from_int (14), 2, svalue_id::null ());
-    map2.impl_set_state (svalue_id::from_int (9), 2, svalue_id::null ());
-
-    ASSERT_EQ (map1.hash (), map2.hash ());
-    ASSERT_EQ (map1, map2);
-  }
-
-  /* Test sm_state_map::remap_svalue_ids.  */
-  {
-    sm_state_map map;
-    svalue_id sid_0 = svalue_id::from_int (0);
-    svalue_id sid_1 = svalue_id::from_int (1);
-    svalue_id sid_2 = svalue_id::from_int (2);
-
-    map.impl_set_state (sid_0, 42, sid_2);
-    ASSERT_EQ (map.get_state (sid_0), 42);
-    ASSERT_EQ (map.get_origin (sid_0), sid_2);
-    ASSERT_EQ (map.get_state (sid_1), 0);
-    ASSERT_EQ (map.get_state (sid_2), 0);
-
-    /* Apply a remapping to the IDs.  */
-    svalue_id_map remapping (3);
-    remapping.put (sid_0, sid_1);
-    remapping.put (sid_1, sid_2);
-    remapping.put (sid_2, sid_0);
-    map.remap_svalue_ids (remapping);
-
-    /* Verify that the IDs have been remapped.  */
-    ASSERT_EQ (map.get_state (sid_1), 42);
-    ASSERT_EQ (map.get_origin (sid_1), sid_0);
-    ASSERT_EQ (map.get_state (sid_2), 0);
-    ASSERT_EQ (map.get_state (sid_0), 0);
-  }
-
   // TODO: coverage for purging
 }
 
@@ -2520,48 +1524,6 @@ test_sm_state_map ()
 static void
 test_program_state_dumping ()
 {
-  /* Create a program_state for a global ptr "p" that has
-     malloc sm-state, pointing to a region on the heap.  */
-  tree p = build_global_decl ("p", ptr_type_node);
-
-  state_machine *sm = make_malloc_state_machine (NULL);
-  const state_machine::state_t UNCHECKED_STATE
-    = sm->get_state_by_name ("unchecked");
-  auto_delete_vec <state_machine> checkers;
-  checkers.safe_push (sm);
-  extrinsic_state ext_state (checkers);
-
-  program_state s (ext_state);
-  region_model *model = s.m_region_model;
-  region_id new_rid = model->add_new_malloc_region ();
-  svalue_id ptr_sid
-      = model->get_or_create_ptr_svalue (ptr_type_node, new_rid);
-  model->set_value (model->get_lvalue (p, NULL),
-		    ptr_sid, NULL);
-  sm_state_map *smap = s.m_checker_states[0];
-
-  smap->impl_set_state (ptr_sid, UNCHECKED_STATE, svalue_id::null ());
-  ASSERT_EQ (smap->get_state (ptr_sid), UNCHECKED_STATE);
-
-#if 0
-  ASSERT_DUMP_EQ
-    (s, ext_state, false,
-     "rmodel: r0: {kind: `root', parent: null, sval: null}\n"
-     "|-heap: r1: {kind: `heap', parent: r0, sval: null}\n"
-     "|  `-r2: {kind: `symbolic', parent: r1, sval: null, possibly_null: true}\n"
-     "`-globals: r3: {kind: `globals', parent: r0, sval: null, map: {`p': r4}}\n"
-     "  `-`p': r4: {kind: `primitive', parent: r3, sval: sv0, type: `void *'}\n"
-     "    |: sval: sv0: {type: `void *', &r2}\n"
-     "    |: type: `void *'\n"
-     "svalues:\n"
-     "  sv0: {type: `void *', &r2}\n"
-     "constraint manager:\n"
-     "  equiv classes:\n"
-     "  constraints:\n"
-     "malloc: {sv0: unchecked (`p')}\n");
-  ASSERT_DUMP_EQ (s, ext_state, true,
-		  "rmodel: p: &r2 malloc: {sv0: unchecked (`p')}");
-#endif
 }
 
 /* Verify that program_state::dump_to_pp works for string literals.  */
@@ -2569,45 +1531,6 @@ test_program_state_dumping ()
 static void
 test_program_state_dumping_2 ()
 {
-    /* Create a program_state for a global ptr "p" that points to
-       a string constant.  */
-  tree p = build_global_decl ("p", ptr_type_node);
-
-  tree string_cst_ptr = build_string_literal (4, "foo");
-
-  auto_delete_vec <state_machine> checkers;
-  extrinsic_state ext_state (checkers);
-
-  program_state s (ext_state);
-  region_model *model = s.m_region_model;
-  region_id p_rid = model->get_lvalue (p, NULL);
-  svalue_id str_sid = model->get_rvalue (string_cst_ptr, NULL);
-  model->set_value (p_rid, str_sid, NULL);
-
-  ASSERT_DUMP_EQ
-    (s, ext_state, false,
-     "rmodel:\n"
-     "r0: {kind: `root', parent: null, sval: null}\n"
-     "|-globals: r1: {kind: `globals', parent: r0, sval: null, map: {`p': r2}}\n"
-     "|  `-`p': r2: {kind: `primitive', parent: r1, sval: sv3, type: `void *'}\n"
-     "|    |: sval: sv3: {type: `void *', &r4}\n"
-     "|    |: type: `void *'\n"
-     "`-r3: {kind: `array', parent: r0, sval: sv0, type: `const char[4]', array: {[0]: r4}}\n"
-     "  |: sval: sv0: {type: `const char[4]', `\"foo\"'}\n"
-     "  |: type: `const char[4]'\n"
-     "  `-[0]: r4: {kind: `primitive', parent: r3, sval: null, type: `const char'}\n"
-     "    |: type: `const char'\n"
-     "svalues:\n"
-     "  sv0: {type: `const char[4]', `\"foo\"'}\n"
-     "  sv1: {type: `int', `0'}\n"
-     "  sv2: {type: `const char *', &r4}\n"
-     "  sv3: {type: `void *', &r4}\n"
-     "constraint manager:\n"
-     "  equiv classes:\n"
-     "  constraints:\n");
-
-  ASSERT_DUMP_EQ (s, ext_state, true,
-		  "{rmodel: {p: &\"foo\"[0]}}");
 }
 
 /* Verify that program_states with identical sm-state can be merged,
@@ -2627,6 +1550,7 @@ test_program_state_merging ()
   extrinsic_state ext_state (checkers);
 
   program_state s0 (ext_state);
+#if 0
   impl_region_model_context ctxt (&s0, NULL, ext_state);
 
   region_model *model0 = s0.m_region_model;
@@ -2673,6 +1597,7 @@ test_program_state_merging ()
 
   /* After canonicalization, we ought to have equality with the inputs.  */
   ASSERT_EQ (s0, merged);
+#endif
 }
 
 /* Verify that program_states with different global-state in an sm-state
@@ -2688,7 +1613,7 @@ test_program_state_merging_2 ()
 
   program_state s0 (ext_state);
   {
-    sm_state_map *smap0 = s0.m_checker_states[0];
+    sm_state_map2 *smap0 = s0.m_checker_states2[0];
     const state_machine::state_t TEST_STATE_0 = 0;
     smap0->set_global_state (TEST_STATE_0);
     ASSERT_EQ (smap0->get_global_state (), TEST_STATE_0);
@@ -2696,7 +1621,7 @@ test_program_state_merging_2 ()
 
   program_state s1 (ext_state);
   {
-    sm_state_map *smap1 = s1.m_checker_states[0];
+    sm_state_map2 *smap1 = s1.m_checker_states2[0];
     const state_machine::state_t TEST_STATE_1 = 1;
     smap1->set_global_state (TEST_STATE_1);
     ASSERT_EQ (smap1->get_global_state (), TEST_STATE_1);
diff --git a/gcc/analyzer/program-state.h b/gcc/analyzer/program-state.h
index f6edf8de65b..22b7a6bf297 100644
--- a/gcc/analyzer/program-state.h
+++ b/gcc/analyzer/program-state.h
@@ -64,161 +64,6 @@ private:
   engine2 *m_engine2;
 };
 
-} // namespace ana
-
-template <> struct default_hash_traits<svalue_id>
-: public pod_hash_traits<svalue_id>
-{
-  static const bool empty_zero_p = false;
-};
-
-template <>
-inline hashval_t
-pod_hash_traits<svalue_id>::hash (value_type v)
-{
-  return v.as_int ();
-}
-
-template <>
-inline bool
-pod_hash_traits<svalue_id>::equal (const value_type &existing,
-				   const value_type &candidate)
-{
-  return existing == candidate;
-}
-template <>
-inline void
-pod_hash_traits<svalue_id>::mark_deleted (value_type &v)
-{
-  v = svalue_id::from_int (-2);
-}
-template <>
-inline void
-pod_hash_traits<svalue_id>::mark_empty (value_type &v)
-{
-  v = svalue_id::null ();
-}
-template <>
-inline bool
-pod_hash_traits<svalue_id>::is_deleted (value_type v)
-{
-  return v.as_int () == -2;
-}
-template <>
-inline bool
-pod_hash_traits<svalue_id>::is_empty (value_type v)
-{
-  return v.null_p ();
-}
-
-namespace ana {
-
-/* Map from svalue_id to state machine state, also capturing the origin of
-   each state.  */
-
-class sm_state_map
-{
-public:
-  /* An entry in the hash_map.  */
-  struct entry_t
-  {
-    /* Default ctor needed by hash_map::empty.  */
-    entry_t ()
-    : m_state (0), m_origin (svalue_id::null ())
-    {
-    }
-
-    entry_t (state_machine::state_t state,
-	     svalue_id origin)
-    : m_state (state), m_origin (origin)
-    {}
-
-    bool operator== (const entry_t &other) const
-    {
-      return (m_state == other.m_state
-	      && m_origin == other.m_origin);
-    }
-    bool operator!= (const entry_t &other) const
-    {
-      return !(*this == other);
-    }
-
-    state_machine::state_t m_state;
-    svalue_id m_origin;
-  };
-  typedef hash_map <svalue_id, entry_t> map_t;
-  typedef map_t::iterator iterator_t;
-
-  sm_state_map ();
-
-  sm_state_map *clone () const;
-
-  sm_state_map *
-  clone_with_remapping (const one_way_svalue_id_map &id_map) const;
-
-  void print (const state_machine &sm, const region_model *model,
-	      pretty_printer *pp) const;
-  void dump (const state_machine &sm) const;
-
-  bool is_empty_p () const;
-
-  hashval_t hash () const;
-
-  bool operator== (const sm_state_map &other) const;
-  bool operator!= (const sm_state_map &other) const
-  {
-    return !(*this == other);
-  }
-
-  state_machine::state_t get_state (svalue_id sid) const;
-  svalue_id get_origin (svalue_id sid) const;
-
-  void set_state (region_model *model,
-		  svalue_id sid,
-		  state_machine::state_t state,
-		  svalue_id origin);
-  bool set_state (const equiv_class &ec,
-		  state_machine::state_t state,
-		  svalue_id origin);
-  bool impl_set_state (svalue_id sid,
-		       state_machine::state_t state,
-		       svalue_id origin);
-
-  void set_global_state (state_machine::state_t state);
-  state_machine::state_t get_global_state () const;
-
-  void purge_for_unknown_fncall (const exploded_graph &eg,
-				 const state_machine &sm,
-				 const gcall *call, tree fndecl,
-				 region_model *new_model,
-				 region_model_context *ctxt);
-
-  void remap_svalue_ids (const svalue_id_map &map);
-
-  int on_svalue_purge (const state_machine &sm,
-		       int sm_idx,
-		       svalue_id first_unused_sid,
-		       const svalue_id_map &map,
-		       impl_region_model_context *ctxt);
-
-  void on_inherited_svalue (svalue_id parent_sid,
-			    svalue_id child_sid);
-
-  void on_cast (svalue_id src_sid,
-		svalue_id dst_sid);
-
-  void on_unknown_change (svalue_id sid);
-
-  void validate (const state_machine &sm, int num_svalues) const;
-
-  iterator_t begin () const { return m_map.begin (); }
-  iterator_t end () const { return m_map.end (); }
-
-private:
-  map_t m_map;
-  state_machine::state_t m_global_state;
-};
-
 /* Map from svalue2 * to state machine state, also capturing the origin of
    each state.  */
 
@@ -385,38 +230,14 @@ public:
 
   bool on_edge (exploded_graph &eg,
 		const exploded_node &enode,
-		const superedge *succ,
-		state_change *change);
+		const superedge *succ);
 
   program_state prune_for_point (exploded_graph &eg,
 				 const program_point &point,
-				 const exploded_node *enode_for_diag,
-				 state_change *change) const;
-  program_state prune_for_point2 (exploded_graph &eg,
-				  const program_point &point,
-				  const exploded_node *enode_for_diag,
-				  state_change *change) const;
-
-  void remap_svalue_ids (const svalue_id_map &map);
+				 const exploded_node *enode_for_diag) const;
 
-  tree get_representative_tree (svalue_id sid) const;
   tree get_representative_tree2 (const svalue2 *sval) const;
 
-  bool can_purge_p (const extrinsic_state &ext_state,
-		    svalue_id sid)
-  {
-    /* Don't purge vars that have non-purgeable sm state, to avoid
-       generating false "leak" complaints.  */
-    int i;
-    sm_state_map *smap;
-    FOR_EACH_VEC_ELT (m_checker_states, i, smap)
-      {
-	const state_machine &sm = ext_state.get_sm (i);
-	if (!sm.can_purge_p (smap->get_state (sid)))
-	  return false;
-      }
-    return true;
-  }
   bool can_purge_p2 (const extrinsic_state &ext_state,
 		     const svalue2 *sval)
   {
@@ -450,12 +271,8 @@ public:
 			     const extrinsic_state &ext_state,
 			     region_model2_context *ctxt);
 
-  /* TODO: eventually eliminate the two models in favor of the new one.  */
-  region_model2 *m_region_model2;
   /* TODO: lose the pointer here (const-correctness issues?).  */
-  region_model *m_region_model;
-  /* TODO: eventually eliminate the two sm_state_maps in favor of the new one.  */
-  auto_delete_vec<sm_state_map> m_checker_states;
+  region_model2 *m_region_model2;
   auto_delete_vec<sm_state_map2> m_checker_states2;
 
   /* If false, then don't attempt to explore further states along this path.
@@ -464,31 +281,6 @@ public:
   bool m_valid;
 };
 
-/* An abstract base class for use with for_each_state_change.  */
-
-class state_change_visitor
-{
-public:
-  virtual ~state_change_visitor () {}
-
-  /* Return true for early exit, false to keep iterating.  */
-  virtual bool on_global_state_change (const state_machine &sm,
-				       state_machine::state_t src_sm_val,
-				       state_machine::state_t dst_sm_val) = 0;
-
-  /* Return true for early exit, false to keep iterating.  */
-  virtual bool on_state_change (const state_machine &sm,
-				state_machine::state_t src_sm_val,
-				state_machine::state_t dst_sm_val,
-				tree dst_rep,
-				svalue_id dst_origin_sid) = 0;
-};
-
-extern bool for_each_state_change (const program_state &src_state,
-				   const program_state &dst_state,
-				   const extrinsic_state &ext_state,
-				   state_change_visitor *visitor);
-
 /* An abstract base class for use with for_each_state_change2.  */
 
 class state_change_visitor2
@@ -519,7 +311,7 @@ extern bool for_each_state_change2 (const program_state &src_state,
    exploded_graph, and for recording sm-state-changes, so that
    values that change aren't purged (to make it easier to generate
    state_change_event instances in the diagnostic_path).  */
-
+#if  0
 class state_change
 {
  public:
@@ -575,6 +367,7 @@ class state_change
  private:
   auto_vec<sm_change> m_sm_changes;
 };
+#endif
 
 } // namespace ana
 
